/*

Chaser checksum calculator 0.1
by Luigi Auriemma
e-mail: aluigi@altervista.org
web:    http://aluigi.altervista.org

This function calculates the 16bit checksum of the packets used
in the game Chaser http://www.chasergame.com/

A Chaser packet is composed as the following:

00 a1 c7 61 61 61 61
|  |     |
|  |     data
|  16bit checksum of data (little endian)
first byte (NULL)

*/



unsigned short chaser_crc(unsigned char *data, int len) {
    unsigned short  ax = 0;

    for(; len; len--, data++) {
        ax = *data ^ ((ax<<8)|(ax>>8));
        ax ^= (ax & 0xff) >> 4;
        ax ^= ax << 0xc;
        ax ^= (ax & 0xff) << 5;
    }

    return(ax);
}
